package ch.jaros.labyrinth;

/**
 * @author Martin Jaros
 */
public class Connector {

	private Labyrinth labyrinth;
	private Finder finder;

	public Connector(Labyrinth labyrinth) {
		this.labyrinth = labyrinth;

		finder = new Finder(labyrinth);
	}

	public void generateConnections() {
		Point nextPoint = null;
		boolean end = false;

		do {
			nextPoint = finder.nextPoint();

			if (nextPoint != null) {
				connectPoints(labyrinth.getPoint(), nextPoint);
		
				gotoPoint(nextPoint);
		
				nextPoint.setTaken(true);
			} else {
				end = !gotoNewPoint();
			}
		} while (!end);
	}

	private boolean gotoNewPoint() {
		boolean ok = false;
		
		Point newPoint = finder.nextJunction();
		ok = (newPoint != null);
				
		if (ok) {
			gotoPoint(newPoint);
		}
		
		return ok;
	}
	
	public void connectPoints(Point point1, Point point2) {
		point1.getConnections().add(point2);
		point2.getConnections().add(point1);
	}

	private void gotoPoint(Point point) {
		labyrinth.setCurrentPosition(point.getPosition());
	}
}