/*
 * Created on 29.12.2004
 */
package ch.jaros.labyrinth;

/**
 * @author Martin
 */
public class LabyrinthFactory {
	public static final int QUAD = 0;
	public static final int HEX = 1;
	public static final int OCT = 2;
	
	public static Labyrinth create(int type, int width, int height) {
		Labyrinth labyrinth = null;
		
		int labyWidth = Math.max(width, 1);
		int labyHeight = Math.max(height, 1);

		if (type == QUAD) {
			labyrinth = new Labyrinth4(labyWidth, labyHeight);
		} else if (type == HEX) {
			labyrinth = new Labyrinth6(labyWidth, labyHeight);
		} else {
			labyrinth = new Labyrinth8(labyWidth, labyHeight);
		}
		
		labyrinth.generate();
		
		return labyrinth;
	}
}
