/*
 * Created on 08.02.2004
 */
package ch.jaros.labyrinth;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Martin Jaros
 */
public class Position4 implements Position {

	public static final Integer NORTH = new Integer(0);
	public static final Integer EAST = new Integer(1);
	public static final Integer SOUTH = new Integer(2);
	public static final Integer WEST = new Integer(3);
	public static final Integer ERROR = new Integer(-1);

	private int x;
	private int y;
	
	public Position4(int x, int y) {
		this.x = x;
		this.y = y;
	}

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}
	
	public List getPositionsAround() {
		List positions = new ArrayList();

		positions.add(new Position4(x - 1, y));
		positions.add(new Position4(x, y + 1));
		positions.add(new Position4(x + 1, y));
		positions.add(new Position4(x, y - 1));

		return positions;
	}
	
	public Integer directionTo(Position dirPos) {
		Integer direction = ERROR;
		int x2 = dirPos.getX();
		int y2 = dirPos.getY();
		
		if ((x == x2) && (y == (y2 + 1))) {
			direction = NORTH;
		} else if ((x == x2) && (y == (y2 - 1))) {
			direction = SOUTH;
		} else if ((x == (x2 + 1)) && (y == y2)) {
			direction = WEST;
		} else if ((x == (x2 - 1)) && (y == y2)) {
			direction = EAST;
		}

		return direction;
	}
}
