/*
 * Created on 08.02.2004
 */
package ch.jaros.labyrinth;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Martin Jaros
 */
public class Position6 implements Position {

	public static final Integer N = new Integer(0);
	public static final Integer NE = new Integer(1);
	public static final Integer SE = new Integer(2);
	public static final Integer S = new Integer(3);
	public static final Integer SW = new Integer(4);
	public static final Integer NW = new Integer(5);
	public static final Integer ERROR = new Integer(-1);

	private int x;
	private int y;
	
	public Position6(int x, int y) {
		this.x = x;
		this.y = y;
	}

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}
	
	public List getPositionsAround() {
		List positions = new ArrayList();

		int difY = 0;

		if (!isEven()) {
			difY = 1;
		}

		positions.add(new Position6(x, y - 1));
		positions.add(new Position6(x + 1, y - 1 + difY));
		positions.add(new Position6(x + 1, y + difY));
		positions.add(new Position6(x, y + 1));
		positions.add(new Position6(x - 1, y + difY));
		positions.add(new Position6(x - 1, y - 1 + difY));

		return positions;
	}

	public Integer directionTo(Position dirPos) {
		Integer direction = ERROR;
		int x2 = dirPos.getX();
		int y2 = dirPos.getY();

		if ((x == x2) && (y == (y2 + 1))) {
			direction = N;
		} else if ((x == x2) && (y == (y2 - 1))) {
			direction = S;
		} else {
			int difY = 0;

			if (isEven()) {
				difY = 1;
			}

			if ((x == (x2 - 1)) && (y == (y2 + difY))) {
				direction = NE;
			} else if ((x == (x2 - 1)) && (y == (y2 - 1 + difY))) {
				direction = SE;
			} else if ((x == (x2 + 1)) && (y == (y2 - 1 + difY))) {
				direction = SW;
			} else if ((x == (x2 + 1)) && (y == (y2 + difY))) {
				direction = NW;
			}
		}

		return direction;
	}

	private boolean isEven() {
		return (((x / 2) * 2) == x);
	}
}
