/*
 * Created on Dec 27, 2004
 */
package ch.jaros.labyrinth;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Martin Jaros
 */
public class Position8 implements Position {

	public static final Integer N = new Integer(0);
	public static final Integer NE = new Integer(1);
	public static final Integer E = new Integer(2);
	public static final Integer SE = new Integer(3);
	public static final Integer S = new Integer(4);
	public static final Integer SW = new Integer(5);
	public static final Integer W = new Integer(6);
	public static final Integer NW = new Integer(7);
	public static final Integer ERROR = new Integer(-1);

	private int x;
	private int y;

	public Position8(int x, int y) {
		this.x = x;
		this.y = y;
	}

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}

	public List getPositionsAround() {
		List positions = new ArrayList();;

		if (isQuad(x, y)) {
			positions.add(new Position8(x, y - 1));
			positions.add(new Position8(x + 1, y));
			positions.add(new Position8(x, y + 1));
			positions.add(new Position8(x - 1, y));
		} else {
			positions.add(new Position8(x, y - 1));
			positions.add(new Position8(x + 1, y - 1));
			positions.add(new Position8(x + 1, y));
			positions.add(new Position8(x + 1, y + 1));
			positions.add(new Position8(x, y + 1));
			positions.add(new Position8(x - 1, y + 1));
			positions.add(new Position8(x - 1, y));
			positions.add(new Position8(x - 1, y - 1));
		}

		return positions;
	}

	public Integer directionTo(Position dirPos) {
		Integer direction = ERROR;
		int x2 = dirPos.getX();
		int y2 = dirPos.getY();

		if ((x == x2) && (y == (y2 + 1))) {
			direction = N;
		} else if ((x == (x2 - 1)) && (y == (y2 + 1))) {
			direction = NE;
		} else if ((x == (x2 - 1)) && (y == y2)) {
			direction = E;
		} else if ((x == (x2 - 1)) && (y == (y2 - 1))) {
			direction = SE;
		} else if ((x == x2) && (y == (y2 - 1))) {
			direction = S;
		} else if ((x == (x2 + 1)) && (y == (y2 - 1))) {
			direction = SW;
		} else if ((x == (x2 + 1)) && (y == y2)) {
			direction = W;
		} else if ((x == (x2 + 1)) && (y == (y2 + 1))) {
			direction = NW;
		}

		return direction;
	}

	public static boolean isQuad(int x, int y) {
		return (isEven(x) && isEven(y)) || (!isEven(x) && !isEven(y));
	}

	private static boolean isEven(int i) {
		return (((i / 2) * 2) == i);
	}
}
