/*
 * Created on Aug 8, 2004
 */
package ch.jaros.labyrinth.applet;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.HeadlessException;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.swing.JApplet;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import ch.jaros.labyrinth.graphic.LabyrinthComponent;
import ch.jaros.labyrinth.graphic.LabyrinthInput;
import ch.jaros.labyrinth.graphic.LabyrinthOutputControls;
import ch.jaros.labyrinth.graphic.OutputGenerator;

/**
 * @author Martin Jaros
 */
public class LabyrinthApplet extends JApplet {

	private JPanel main = new JPanel(new GridBagLayout());
	private LabyrinthInput labyrinthInput;
	private LabyrinthOutputControls labyrinthOutputControls;
	private LabyrinthComponent labyrinthComponent;

	private JScrollPane scroll = new JScrollPane();

	public LabyrinthApplet() throws HeadlessException {
		labyrinthInput = new LabyrinthInput();
		labyrinthComponent = new LabyrinthComponent();
		labyrinthOutputControls =
			new LabyrinthOutputControls(labyrinthComponent);

		scroll.getViewport().add(labyrinthComponent);

		GridBagConstraints constraints = new GridBagConstraints();
		constraints.gridx = 0;
		constraints.gridy = 0;
		main.add(labyrinthInput, constraints);
		constraints.gridy++;
		constraints.insets = new Insets(5, 5, 5, 5);
		main.add(labyrinthOutputControls.getCellPanel(), constraints);
		constraints.gridy++;
		main.add(labyrinthOutputControls.getPrintButton(), constraints);
		constraints.insets = new Insets(0, 0, 0, 0);
		constraints.gridx = 1;
		constraints.gridy = 0;
		constraints.gridheight = 4;
		constraints.weightx = 1;
		constraints.weighty = 1;
		constraints.fill = GridBagConstraints.BOTH;
		main.add(scroll, constraints);

		this.getContentPane().add(main);

		labyrinthInput
			.getGenerateButton()
			.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				generate();
			}
		});

		labyrinthInput.getHeightText().addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == KeyEvent.VK_ENTER) {
					generate();
				}
			}
		});

		labyrinthInput.getWidthText().addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == KeyEvent.VK_ENTER) {
					generate();
				}
			}
		});

		labyrinthOutputControls
			.getPrintButton()
			.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					OutputGenerator.print(labyrinthComponent);
				}
		});
	}

	private void generate() {
		OutputGenerator.generate(labyrinthInput, labyrinthComponent);

		scroll.doLayout();
		scroll.repaint();
	}
}
