/*
 * Created on Jun 13, 2004
 */
package ch.jaros.labyrinth.application;

import java.awt.Component;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;

import ch.jaros.labyrinth.graphic.LabyrinthInput;

/**
 * @author Martin Jaros
 */
public class InputWindow extends JFrame {

	private LabyrinthInput labyrinthInput;

	private static int WINDOW_WIDTH = 250;
	private static int WINDOW_HEIGHT = 200;

	public InputWindow(LabyrinthInput labyrinthInput) {
		super("Labyrinth-Generator");
		
		this.labyrinthInput = labyrinthInput;
		
		this.getContentPane().add(labyrinthInput);
		this.setSize(WINDOW_WIDTH, WINDOW_HEIGHT);

		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent arg0) {
				InputWindow.close();
			}
		});

		this.addComponentListener(new ComponentAdapter() {
			public void componentResized(ComponentEvent e) {
				Component component = e.getComponent();
				int width =
					component.getWidth() < WINDOW_WIDTH
						? WINDOW_WIDTH
						: component.getWidth();
				int height =
					component.getHeight() < WINDOW_HEIGHT
						? WINDOW_HEIGHT
						: component.getHeight();
				component.setSize(width, height);
			}
		});
	}

	public static void close() {
		System.exit(0);
	}
}
