/*
 * Created on 29.12.2004
 */
package ch.jaros.labyrinth.application;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import ch.jaros.labyrinth.graphic.LabyrinthComponent;
import ch.jaros.labyrinth.graphic.LabyrinthInput;
import ch.jaros.labyrinth.graphic.LabyrinthOutputControls;
import ch.jaros.labyrinth.graphic.OutputGenerator;

/**
 * @author Martin
 */
public class Main {
	public static void main(String[] args) {
		final LabyrinthInput labyrinthInput = new LabyrinthInput();

		InputWindow inputWindow = new InputWindow(labyrinthInput);
		inputWindow.pack();
		inputWindow.setVisible(true);

		labyrinthInput.getHeightText().requestFocus();

		labyrinthInput
			.getGenerateButton()
			.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				generate(labyrinthInput);
			}
		});

		labyrinthInput.getHeightText().addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == KeyEvent.VK_ENTER) {
					generate(labyrinthInput);
				}
			}
		});

		labyrinthInput.getWidthText().addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == KeyEvent.VK_ENTER) {
					generate(labyrinthInput);
				}
			}
		});
	}

	private static void generate(LabyrinthInput labyrinthInput) {
		LabyrinthComponent labyrinthComponent = new LabyrinthComponent();
		OutputGenerator.generate(labyrinthInput, labyrinthComponent);

		LabyrinthOutputControls labyrinthOutputControls =
			new LabyrinthOutputControls(labyrinthComponent);

		OutputWindow outputWindow = new OutputWindow(labyrinthOutputControls);
		outputWindow.setVisible(true);

	}
}
