/*
 * Created on 08.02.2004
 */
package ch.jaros.labyrinth.graphic;

import java.awt.Graphics;
import java.util.List;

import ch.jaros.labyrinth.Labyrinth;
import ch.jaros.labyrinth.Point;
import ch.jaros.labyrinth.Position4;

/**
 * @author Martin Jaros
 */
public class LabyrinthGraphic4 extends AbstractLabyrinthGraphic {

	public LabyrinthGraphic4(Labyrinth labyrinth) {
		super(labyrinth);
	}

	protected void drawPoint(Point point, Graphics graphics, double factor, double imageOffsetX, double imageOffsetY) {
		List directions = getDirections(point);
		int x = point.getPosition().getX();
		int y = point.getPosition().getY();
		double xDraw = x * factor + imageOffsetX;
		double yDraw = y * factor + imageOffsetY;

		if (!directions.contains(Position4.NORTH)) {
			graphics.drawLine(
				round(xDraw),
				round(yDraw),
				round(xDraw + factor),
				round(yDraw));
		}
		if (!directions.contains(Position4.SOUTH)) {
			graphics.drawLine(
				round(xDraw),
				round(yDraw + factor),
				round(xDraw + factor),
				round(yDraw + factor));
		}
		if (!directions.contains(Position4.WEST)) {
			graphics.drawLine(
				round(xDraw),
				round(yDraw),
				round(xDraw),
				round(yDraw + factor));
		}
		if (!directions.contains(Position4.EAST)) {
			graphics.drawLine(
				round(xDraw + factor),
				round(yDraw),
				round(xDraw + factor),
				round(yDraw + factor));
		}
	}
}
