/*
 * Created on 08.02.2004
 */
package ch.jaros.labyrinth.graphic;

import java.awt.Graphics;
import java.util.List;

import ch.jaros.labyrinth.Labyrinth;
import ch.jaros.labyrinth.Point;
import ch.jaros.labyrinth.Position6;

/**
 * @author Martin Jaros
 */
public class LabyrinthGraphic6 extends AbstractLabyrinthGraphic {

	private double deltaX;
	private double deltaX2;
	private double deltaY;
	private double deltaY2;

	public LabyrinthGraphic6(Labyrinth labyrinth) {
		super(labyrinth);
	}

	private void caculateDeltas(double factor) {
		deltaX = factor + (Math.sin(Math.PI / 6) * factor);
		deltaX2 = Math.sin(Math.PI / 6) * factor;
		deltaY = 2 * (Math.cos(Math.PI / 6) * factor);
		deltaY2 = Math.cos(Math.PI / 6) * factor;

	}

	protected void drawPoint(
		Point point,
		Graphics graphics,
		double factor,
		double imageOffsetX,
		double imageOffsetY) {
		caculateDeltas(factor);

		List directions = getDirections(point);
		int x = point.getPosition().getX();
		int y = point.getPosition().getY();
		boolean even = (((x / 2) * 2) == x);
		double xDraw = x * deltaX + imageOffsetX;
		double yDraw = y * deltaY + imageOffsetY;
		if (!even) {
			yDraw += deltaY2;
		}

		if (!directions.contains(Position6.N)) {
			graphics.drawLine(
				round(xDraw + deltaX2),
				round(yDraw),
				round(xDraw + deltaX),
				round(yDraw));
		}
		if (!directions.contains(Position6.S)) {
			graphics.drawLine(
				round(xDraw + deltaX2),
				round(yDraw + deltaY),
				round(xDraw + deltaX),
				round(yDraw + deltaY));
		}
		if (!directions.contains(Position6.NW)) {
			graphics.drawLine(
				round(xDraw),
				round(yDraw + deltaY2),
				round(xDraw + deltaX2),
				round(yDraw));
		}
		if (!directions.contains(Position6.NE)) {
			graphics.drawLine(
				round(xDraw + deltaX),
				round(yDraw),
				round(xDraw + deltaX + deltaX2),
				round(yDraw + deltaY2));
		}
		if (!directions.contains(Position6.SW)) {
			graphics.drawLine(
				round(xDraw),
				round(yDraw + deltaY2),
				round(xDraw + deltaX2),
				round(yDraw + deltaY));
		}
		if (!directions.contains(Position6.SE)) {
			graphics.drawLine(
				round(xDraw + deltaX),
				round(yDraw + deltaY),
				round(xDraw + deltaX + deltaX2),
				round(yDraw + deltaY2));
		}
	}
}
