/*
 * Created on 08.02.2004
 */
package ch.jaros.labyrinth.graphic;

import java.awt.Graphics;
import java.util.List;

import ch.jaros.labyrinth.Labyrinth;
import ch.jaros.labyrinth.Point;
import ch.jaros.labyrinth.Position8;

/**
 * @author Martin Jaros
 */
public class LabyrinthGraphic8 extends AbstractLabyrinthGraphic {

	public LabyrinthGraphic8(Labyrinth labyrinth) {
		super(labyrinth);
	}

	protected void drawPoint(
		Point point,
		Graphics graphics,
		double factor,
		double imageOffsetX,
		double imageOffsetY) {

		double delta = factor / Math.sqrt(2);
		double delta2 = factor;

		List directions = getDirections(point);
		int x = point.getPosition().getX();
		int y = point.getPosition().getY();
		double xDraw = x * (delta + delta2) + imageOffsetX;
		double yDraw = y * (delta + delta2) + imageOffsetY;

		if (Position8.isQuad(x, y)) {
			if (!directions.contains(Position8.N)) {
				graphics.drawLine(
					round(xDraw + delta),
					round(yDraw + delta),
					round(xDraw + delta + delta2),
					round(yDraw + delta));
			}
			if (!directions.contains(Position8.E)) {
				graphics.drawLine(
					round(xDraw + delta + delta2),
					round(yDraw + delta),
					round(xDraw + delta + delta2),
					round(yDraw + delta + delta2));
			}
			if (!directions.contains(Position8.S)) {
				graphics.drawLine(
					round(xDraw + delta),
					round(yDraw + delta + delta2),
					round(xDraw + delta + delta2),
					round(yDraw + delta + delta2));
			}
			if (!directions.contains(Position8.W)) {
				graphics.drawLine(
					round(xDraw + delta),
					round(yDraw + delta),
					round(xDraw + delta),
					round(yDraw + delta + delta2));
			}
		} else {
			if (!directions.contains(Position8.N)) {
				graphics.drawLine(
					round(xDraw + delta),
					round(yDraw + 0),
					round(xDraw + delta + delta2),
					round(yDraw + 0));
			}
			if (!directions.contains(Position8.NE)) {
				graphics.drawLine(
					round(xDraw + delta + delta2),
					round(yDraw + 0),
					round(xDraw + 2 * delta + delta2),
					round(yDraw + delta));
			}
			if (!directions.contains(Position8.E)) {
				graphics.drawLine(
					round(xDraw + 2 * delta + delta2),
					round(yDraw + delta),
					round(xDraw + 2 * delta + delta2),
					round(yDraw + delta + delta2));
			}
			if (!directions.contains(Position8.SE)) {
				graphics.drawLine(
					round(xDraw + 2 * delta + delta2),
					round(yDraw + delta + delta2),
					round(xDraw + delta + delta2),
					round(yDraw + 2 * delta + delta2));
			}
			if (!directions.contains(Position8.S)) {
				graphics.drawLine(
					round(xDraw + delta),
					round(yDraw + 2 * delta + delta2),
					round(xDraw + delta + delta2),
					round(yDraw + 2 * delta + delta2));
			}
			if (!directions.contains(Position8.SW)) {
				graphics.drawLine(
					round(xDraw + 0),
					round(yDraw + delta + delta2),
					round(xDraw + delta),
					round(yDraw + 2 * delta + delta2));
			}
			if (!directions.contains(Position8.W)) {
				graphics.drawLine(
					round(xDraw + 0),
					round(yDraw + delta),
					round(xDraw + 0),
					round(yDraw + delta + delta2));
			}
			if (!directions.contains(Position8.NW)) {
				graphics.drawLine(
					round(xDraw + 0),
					round(yDraw + delta),
					round(xDraw + delta),
					round(yDraw + 0));
			}
		}
	}
}
