/*
 * Created on Aug 8, 2004
 */
package ch.jaros.labyrinth.graphic;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;

/**
 * @author Martin Jaros
 */
public class LabyrinthInput extends JPanel {
	private JPanel inputPanel = new JPanel(new GridBagLayout());
	private JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
	private JLabel heightLabel = new JLabel("Hhe:");
	private JLabel widthLabel = new JLabel("Breite:");
	private JLabel typeLabel = new JLabel("Typ:");
	private JTextField heightText = new JTextField();
	private JTextField widthText = new JTextField();
	private JRadioButton typeQuadButton = new JRadioButton("Quad");
	private JRadioButton typeHexButton = new JRadioButton("Hex");
	private JRadioButton typeOctButton = new JRadioButton("Oct");
	private ButtonGroup typeButtonGroup = new ButtonGroup();
	private JButton generateButton = new JButton("Generieren");

	public LabyrinthInput() {
		super(new BorderLayout());

		this.add(buttonPanel, BorderLayout.SOUTH);
		inputPanel.setBorder(new EtchedBorder());
		this.add(inputPanel, BorderLayout.CENTER);
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.fill = GridBagConstraints.HORIZONTAL;
		constraints.gridx = 0;
		constraints.gridy = 0;
		constraints.insets = new Insets(2, 2, 2, 2);
		inputPanel.add(heightLabel, constraints);
		constraints.gridx = 1;
		constraints.weightx = 0;
		inputPanel.add(heightText, constraints);
		constraints.gridx = 0;
		constraints.gridy = 1;
		constraints.weightx = 0;
		inputPanel.add(widthLabel, constraints);
		constraints.gridx = 1;
		inputPanel.add(widthText, constraints);
		constraints.gridx = 0;
		constraints.gridy = 2;
		inputPanel.add(typeLabel, constraints);
		constraints.gridx = 1;
		constraints.insets = new Insets(0, 2, 0, 2);
		inputPanel.add(typeQuadButton, constraints);
		constraints.gridy = 3;
		inputPanel.add(typeHexButton, constraints);
		constraints.gridy = 4;
		inputPanel.add(typeOctButton, constraints);
		buttonPanel.add(generateButton);

		typeButtonGroup.add(typeQuadButton);
		typeButtonGroup.add(typeHexButton);
		typeButtonGroup.add(typeOctButton);
		typeQuadButton.setSelected(true);
	}

	public JButton getGenerateButton() {
		return generateButton;
	}

	public JLabel getHeightLabel() {
		return heightLabel;
	}

	public JTextField getHeightText() {
		return heightText;
	}

	public JRadioButton getTypeHexButton() {
		return typeHexButton;
	}

	public JRadioButton getTypeOctButton() {
		return typeOctButton;
	}

	public JRadioButton getTypeQuadButton() {
		return typeQuadButton;
	}

	public JTextField getWidthText() {
		return widthText;
	}
}
