/*
 * Created on 30.12.2004
 */
package ch.jaros.labyrinth.graphic;

import java.awt.BorderLayout;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * @author Martin Jaros
 */
public class LabyrinthOutputControls {

	private LabyrinthComponent labyrinthComponent;

	private JPanel cellPanel = new JPanel(new BorderLayout());

	private JLabel cellLabel = new JLabel("Zellengrsse:");
	private JSpinner cellInput =
		new JSpinner(new SpinnerNumberModel(10, 5, 25, 1));

	private JButton printButton = new JButton("Drucken");

	public LabyrinthOutputControls(LabyrinthComponent labyrinthComponent) {
		this.labyrinthComponent = labyrinthComponent;

		cellPanel.add(cellLabel, BorderLayout.WEST);
		cellPanel.add(cellInput, BorderLayout.CENTER);

		cellInput.setValue(new Integer(labyrinthComponent.getCellSize()));

		cellInput.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				int value = ((Integer) cellInput.getValue()).intValue();
				LabyrinthOutputControls.this.labyrinthComponent.setCellSize(
					value);
			}
		});
	}

	public JButton getPrintButton() {
		return printButton;
	}

	public JPanel getCellPanel() {
		return cellPanel;
	}

	public LabyrinthComponent getLabyrinthComponent() {
		return labyrinthComponent;
	}
}
