/*
 * Created on Aug 8, 2004
 */
package ch.jaros.labyrinth.graphic;

import java.awt.print.PrinterJob;

import ch.jaros.labyrinth.Labyrinth;
import ch.jaros.labyrinth.LabyrinthFactory;

/**
 * @author Martin Jaros
 */
public class OutputGenerator {

	public static void generate(LabyrinthInput labyrinthInput, LabyrinthComponent labyrinthComponent) {
		int height = 1;
		int width = 1;

		try {
			height = Integer.parseInt(labyrinthInput.getHeightText().getText());
		} catch (NumberFormatException e) {
		}

		try {
			width = Integer.parseInt(labyrinthInput.getWidthText().getText());
		} catch (NumberFormatException e) {
		}

		int type = 0;

		if (labyrinthInput.getTypeQuadButton().isSelected()) {
			type = LabyrinthFactory.QUAD;
		} else if (labyrinthInput.getTypeHexButton().isSelected()) {
			type = LabyrinthFactory.HEX;
		} else if (labyrinthInput.getTypeOctButton().isSelected()) {
			type = LabyrinthFactory.OCT;
		}

		Labyrinth labyrinth = LabyrinthFactory.create(type, width, height);
		
		labyrinthComponent.setLabyrinth(labyrinth);
	}

	public static void print(LabyrinthComponent labyrinthComponent) {
		PrinterJob printJob = PrinterJob.getPrinterJob();
		printJob.setPrintable(labyrinthComponent);
		if (printJob.printDialog()) {
			try {
				printJob.print();
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
	}
}
